//+------------------------------------------------------------------+
//|                                                  Grid Trader.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

//---- input parameters
extern double    GridUpperLimit=1.2600;         // Will not set up pending orders above this price
extern double    GridLowerLimit=1.2100;         // Will not set up pending orders below this price
extern double    Lots=0.10;                     // Lot size
extern int       GridDirection=1;               // 1=Long; -1=Short
extern int       GridSpacing=5;                 // Space between pending orders
extern int       ProfitLimit=20;                // TP
extern int       PlaceOrderFromPricePips=15;    // Keeps new orders at least X pips away from the current price 
extern int       KillOrders=0;                  // Deletes pending orders when set to 1 (must then be reset to 0)
extern int       KillPositions=0;               // Deletes open orders when set to 1 (must then be reset to 0)

int Ticket=0,Index=0,Total=0,OrderFound=0;
double CurrentLevel=0.00;



int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
  {
   
   
    //KILL ORDERS & POSITIONS
    Total=OrdersTotal();
   
    for(Index=0;Index<Total;Index++)
    { 
      OrderSelect(Index, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol()==Symbol())
    	{
    	    if(KillPositions == 1)
    	    {
    	       if(OrderType() == OP_BUY)
    	       {
    	          OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
    	       }
    	 
    	       if(OrderType() == OP_SELL)
    	       {  
    	          OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
    	       }
    	    }
    	 
    	    if(KillOrders == 1)
    	    {
    	       if(OrderType() == OP_BUYLIMIT)
    	       {
    	          OrderDelete(OrderTicket());
    	       }
    	 
    	       if(OrderType() == OP_BUYSTOP)
    	       {
    	          OrderDelete(OrderTicket());
    	       }
    	 
    	       if(OrderType() == OP_SELLLIMIT)
    	       {
    	          OrderDelete(OrderTicket());
    	       }
    	 
    	       if(OrderType() == OP_SELLSTOP)
    	       {
    	          OrderDelete(OrderTicket());
    	       }
    	    } 
    	 }
    }
   
   if(KillPositions == 0 && KillOrders == 0)
   {

      //ADD NEW ORDERS TO THE GRID
      CurrentLevel = GridLowerLimit;

      while(CurrentLevel < GridUpperLimit)
      {
         OrderFound=0;
         Total=OrdersTotal();
      
         for(Index=0;Index<Total;Index++)
         { 
            OrderSelect(Index, SELECT_BY_POS, MODE_TRADES);
         
            if(GridDirection==1)
            {
               if(OrderSymbol()==Symbol() && (OrderType()==OP_BUY || OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT))
    	         {

                  if(NormalizeDouble(OrderOpenPrice(),4) == NormalizeDouble(CurrentLevel,4))
                  {
                     OrderFound = 1;
                     break;
                  }
           
         
               }
            }
         
         
            if(GridDirection==-1)
            {
               if(OrderSymbol()==Symbol() && (OrderType()==OP_SELL || OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT))
    	         {

                  if(NormalizeDouble(OrderOpenPrice(),4) == NormalizeDouble(CurrentLevel,4))
                  {
                     OrderFound = 1;
                     break;
                  }
           
         
               }
            }
         
         
         
         }
      
    
     
         // Order does not exist, so create a new one
         if(OrderFound ==0)
         {
         
            if(GridDirection==1)
            {
               if(CurrentLevel > (Ask + (Point * PlaceOrderFromPricePips)))     //ONLY BUY ABOVE ASK PRICE 
               {
                  Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,CurrentLevel,0,0,CurrentLevel + (Point*ProfitLimit),"BUYSTOP",0,0,Black);
                  Sleep(1000);
               }
            }
         
            if(GridDirection == -1)
            {
               if(CurrentLevel < (Bid - (Point * PlaceOrderFromPricePips)))
               {
                  Ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,CurrentLevel,0,0,CurrentLevel - (Point*ProfitLimit),"SELLSTOP",0,0,Black);
                  Sleep(1000);
               }
            
            }
         
         }

         CurrentLevel = CurrentLevel + (GridSpacing * Point);
      
      }
   }
   
   return(0);
  }